# coding: utf-8

"""
    FINBOURNE Workflow API

    FINBOURNE Technology  # noqa: E501

    The version of the OpenAPI document: 0.1.159
    Contact: info@finbourne.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from lusid_workflow.configuration import Configuration


class TaskDefinitionId(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
      required_map (dict): The key is attribute name
                           and the value is whether it is 'required' or 'optional'.
    """
    openapi_types = {
        'scope': 'str',
        'code': 'str',
        'version': 'int'
    }

    attribute_map = {
        'scope': 'scope',
        'code': 'code',
        'version': 'version'
    }

    required_map = {
        'scope': 'optional',
        'code': 'optional',
        'version': 'optional'
    }

    def __init__(self, scope=None, code=None, version=None, local_vars_configuration=None):  # noqa: E501
        """TaskDefinitionId - a model defined in OpenAPI"
        
        :param scope:  Identifer
        :type scope: str
        :param code:  Human readable Key
        :type code: str
        :param version:  Numeric versioning support
        :type version: int

        """  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._scope = None
        self._code = None
        self._version = None
        self.discriminator = None

        self.scope = scope
        self.code = code
        if version is not None:
            self.version = version

    @property
    def scope(self):
        """Gets the scope of this TaskDefinitionId.  # noqa: E501

        Identifer  # noqa: E501

        :return: The scope of this TaskDefinitionId.  # noqa: E501
        :rtype: str
        """
        return self._scope

    @scope.setter
    def scope(self, scope):
        """Sets the scope of this TaskDefinitionId.

        Identifer  # noqa: E501

        :param scope: The scope of this TaskDefinitionId.  # noqa: E501
        :type scope: str
        """

        self._scope = scope

    @property
    def code(self):
        """Gets the code of this TaskDefinitionId.  # noqa: E501

        Human readable Key  # noqa: E501

        :return: The code of this TaskDefinitionId.  # noqa: E501
        :rtype: str
        """
        return self._code

    @code.setter
    def code(self, code):
        """Sets the code of this TaskDefinitionId.

        Human readable Key  # noqa: E501

        :param code: The code of this TaskDefinitionId.  # noqa: E501
        :type code: str
        """

        self._code = code

    @property
    def version(self):
        """Gets the version of this TaskDefinitionId.  # noqa: E501

        Numeric versioning support  # noqa: E501

        :return: The version of this TaskDefinitionId.  # noqa: E501
        :rtype: int
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this TaskDefinitionId.

        Numeric versioning support  # noqa: E501

        :param version: The version of this TaskDefinitionId.  # noqa: E501
        :type version: int
        """

        self._version = version

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TaskDefinitionId):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, TaskDefinitionId):
            return True

        return self.to_dict() != other.to_dict()
